// Sensor
#include <zephyr.h>
#include <device.h>
#include <drivers/sensor.h>
#include <drivers/gpio.h>
#include <stdio.h>
#include <pm/pm.h>
#include <pm/device.h>
#include <pm/policy.h>


#include <inttypes.h>
#include "Pressure.h"


// sensor adjustments - only used for mpu9250 temperature measurements (-6.0°C)
#define SENSOR_OFFSET_TEMPERATURE 0
#define SENSOR_MULTIPLIER_PRESSURE 2

//struct sensor_value sensor_pressure;
struct sensor_value temp;
struct sensor_value press;



/****************************************************************
 * Get pressure from MS5637
*/
uint16_t get_pressure(const struct device *pressure,const struct device *gpio)
{
	
	pm_device_action_run(pressure,PM_DEVICE_ACTION_TURN_ON);
	int rc = sensor_sample_fetch_chan(pressure,SENSOR_CHAN_PRESS);
	pm_device_action_run(pressure,PM_DEVICE_ACTION_TURN_OFF);
	
	if (rc == 0) {
		rc = sensor_channel_get(pressure, SENSOR_CHAN_PRESS,&press);
		//rc = sensor_channel_get(dev, SENSOR_CHAN_AMBIENT_TEMP,&temp);
		printf("%g hPa\n", sensor_value_to_double(&press)*10*SENSOR_MULTIPLIER_PRESSURE);

	}else{
		printk("cannot fetch pressure sensor \n");
	}
	return (sensor_value_to_double(&press)*10*SENSOR_MULTIPLIER_PRESSURE);
}

 uint16_t get_pressure_temperature(const struct device *pressure,const struct device *gpio){
	
	pm_device_action_run(pressure,PM_DEVICE_ACTION_TURN_ON);
	int rc = sensor_sample_fetch_chan(pressure,SENSOR_CHAN_AMBIENT_TEMP);
	pm_device_action_run(pressure,PM_DEVICE_ACTION_TURN_OFF);

	if (rc == 0) {
		rc = sensor_channel_get(pressure, SENSOR_CHAN_AMBIENT_TEMP,&temp);
		//rc = sensor_channel_get(dev, SENSOR_CHAN_AMBIENT_TEMP,&temp);
		printf("%g °C\n", sensor_value_to_double(&temp));
	}
	return sensor_value_to_double(&temp)*100;
 }




int fetchtemp(const struct device *dev){
	//int rc = sensor_sample_fetch(dev);
	int rc = sensor_sample_fetch_chan(dev,SENSOR_CHAN_AMBIENT_TEMP);
	if (rc == 0) {
		//rc = sensor_channel_get(dev, SENSOR_CHAN_PRESS,&press);
		rc = sensor_channel_get(dev, SENSOR_CHAN_AMBIENT_TEMP,&temp);
	}
	else {
		return 1;
	}
	return rc;	
}
